%% Exercice 01: Number vs. Volume distributions
% Statistical Analysis

%% Loading features into Matlab
%  Features were extracted by ImageJ an located into a 'txt' file

clear, clc, close all;
A_type = importdata('A_type.txt');
B_type = importdata('B_type.txt');
C_type = importdata('C_type.txt');

%% Outlier removal

A_maxf = A_type.data(:,5);
A_ind = find(A_maxf > 13);
A_type.data(A_ind,:)=[];

B_maxf = B_type.data(:,5);
B_ind = find(B_maxf > 11);
B_type.data(B_ind,:)=[];

C_maxf = C_type.data(:,5)
C_ind = find(C_maxf > 9);
C_type.data(C_ind,:)=[];

%% Data preparation

A_area = A_type.data(:,2);
A_perim = A_type.data(:,3);
A_circ = A_type.data(:,4);
A_maxf = A_type.data(:,5); % max Feret's diameter
A_angf = A_type.data(:,8); % Feret's angle
A_minf = A_type.data(:,9); % min Feret's diameter
A_asrat = A_type.data(:,10);
A_rndness = A_type.data(:,11);
A_solid = A_type.data(:,12);

B_area = B_type.data(:,2);
B_perim = B_type.data(:,3);
B_circ = B_type.data(:,4);
B_maxf = B_type.data(:,5); % max Feret's diameter
B_angf = B_type.data(:,8); % Feret's angle
B_minf = B_type.data(:,9); % min Feret's diameter
B_asrat = B_type.data(:,10);
B_rndness = B_type.data(:,11);
B_solid = B_type.data(:,12);

C_area = C_type.data(:,2);
C_perim = C_type.data(:,3);
C_circ = C_type.data(:,4);
C_maxf = C_type.data(:,5); % max Feret's diameter
C_angf = C_type.data(:,8); % Feret's angle
C_minf = C_type.data(:,9); % min Feret's diameter
C_asrat = C_type.data(:,10);
C_rndness = C_type.data(:,11);
C_solid = C_type.data(:,12);

%% Particle Number Weighted Distributions

maxf = [A_maxf; B_maxf; C_maxf];
% particle size (diameter) distribution
% we use the maximum Feret as the particle diameter
[n, x] = hist(maxf, 100);
figure('Name','PSD (number weighthed)', 'NumberTitle','off');
bar(x, n/(sum(n))), xlabel('diameter (mm)'), ylabel('relative %');

%% Plots
area= [A_area; B_area; C_area]
perim = [A_perim; B_perim; C_perim]
asrat = [A_asrat; B_asrat; C_asrat];
rndness = [A_rndness; B_rndness; C_rndness];
maxf = [A_maxf; B_maxf; C_maxf];
minf = [A_minf; B_minf; C_minf];

figure('Name','PSD (number weighthed)', 'NumberTitle','off');
subplot(2,3,1), hist(area, 100), xlabel('area (mm^2)'), ylabel('objects');
subplot(2,3,2), hist(perim, 100); xlabel('perimeter (mm)');
subplot(2,3,3), hist(asrat, 100); xlabel('aspect ratio');
subplot(2,3,4), hist(rndness, 100); xlabel('shape factor');
subplot(2,3,5), hist(maxf, 100), xlabel('max Feret'), ylabel('objects');
subplot(2,3,6), hist(minf, 100), xlabel('min Feret');

%%
%scatter plots
c = corr(area, perim);
figure('Name','Scatter plot', 'NumberTitle','off');
scatter(area, perim, '.b');
title(['correlation = ' num2str(c)]);
xlabel('area (mm^2)'), ylabel('perimetre (mm)');

figure('Name','Scatter plot', 'NumberTitle','off');
scatter(area, asrat, '.b');
xlabel('area (mm^2)'), ylabel('aspect ratio');

figure('Name','Scatter plot', 'NumberTitle','off');
scatter(perim, asrat, '.b');
xlabel('perimetre (mm)'), ylabel('aspect ratio');

figure('Name','Scatter plot', 'NumberTitle','off');
scatter3(area, perim, asrat, '.b');
xlabel('area (mm^2)'), ylabel('perimeter (mm)'), zlabel('aspect ratio');

%% Particle Volume Weighted Distributions
% we let to the reader the implementation of this part
